Index: /trunk/src/sys/arch/mips/rmi/rmixl_intr.h
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_intr.h	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_intr.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_intr.h,v 1.1.2.3 2010/04/13 18:15:16 cliff Exp $	*/
+/*	$NetBSD: rmixl_intr.h,v 1.1.2.8 2011/04/29 08:26:32 matt Exp $	*/
 /*-
  * Copyright (c) 2010 The NetBSD Foundation, Inc.
@@ -32,10 +32,15 @@
 #define _MIPS_RMI_RMIXL_INTR_H_
 
+#ifdef _KERNEL_OPT
+#include "opt_multiprocessor.h"
+#endif
+
 /*
- * An 'irq' is an EIRR bit numbers or 'vector' as used in the PRM
- * - PIC-based irqs are in the range 0..31 and index into the IRT
- * - IRT entry <n> always routes to vector <n>
- * - non-PIC-based irqs are in the range 32..63
- * - only 1 intrhand_t per irq/vector
+ * A 'vector' is bit number in EIRR/EIMR
+ * - non-IRT-based interrupts use vectors 0..31
+ * - IRT-based interrupts use vectors 32..63 
+ * - RMIXL_VECTOR_IRT(vec) is used to index into the IRT
+ * - IRT entry n always routes to vector RMIXL_IRT_VECTOR(n)
+ * - only 1 intrhand_t per vector
  */
 #define	NINTRVECS	64	/* bit width of the EIRR */
@@ -43,8 +48,21 @@
 
 /*
- * reserved vectors >=32
+ * mapping between IRT index and vector number
  */
-#define RMIXL_INTRVEC_IPI	32
-#define RMIXL_INTRVEC_FMN	33
+#define RMIXL_VECTOR_IS_IRT(vec)	((vec) >= 32)
+#define RMIXL_IRT_VECTOR(irt)		((irt) + 32)
+#define RMIXL_VECTOR_IRT(vec)		((vec) - 32)
+
+/*
+ * vectors (0 <= vec < 8)  are CAUSE[8..15] (including softintrs and count/compare)
+ * vectors (8 <= vec < 31) are for other non-IRT based interrupts
+ * we use one for FMN, and each IPI currently gets own vector;
+ * if NIPIS >= (32 - 8 - 1), then redesign so IPIs share vector(s)
+ */
+#if NIPIS >= 23
+# error too many IPIs
+#endif
+#define RMIXL_INTRVEC_IPI	8
+#define RMIXL_INTRVEC_FMN	(RMIXL_INTRVEC_IPI + NIPIS)
 
 typedef enum {
@@ -70,5 +88,5 @@
         void *ih_arg; 
         int ih_mpsafe; 			/* true if does not need kernel lock */
-        int ih_irq;			/* >=32 if not-PIC-based */
+        int ih_vec;			/* vector is bit number in EIRR/EIMR */
         int ih_ipl; 			/* interrupt priority */
         int ih_cpumask; 		/* CPUs which may handle this irpt */
@@ -90,7 +108,7 @@
 extern const char *rmixl_intr_string(int);
 extern void rmixl_intr_init_cpu(struct cpu_info *);
-extern void *rmixl_intr_init_clk(void);
+extern void rmixl_intr_init_clk(void);
 #ifdef MULTIPROCESSOR
-extern void *rmixl_intr_init_ipi(void);
+extern void rmixl_intr_init_ipi(void);
 #endif
 
Index: /trunk/src/sys/arch/mips/rmi/rmixl_ohci.c
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_ohci.c	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_ohci.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_ohci.c,v 1.1.2.4 2010/03/21 21:24:48 cliff Exp $	*/
+/*	$NetBSD: rmixl_ohci.c,v 1.1.2.5 2011/04/29 08:26:33 matt Exp $	*/
 
 /*-
@@ -33,5 +33,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: rmixl_ohci.c,v 1.1.2.4 2010/03/21 21:24:48 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: rmixl_ohci.c,v 1.1.2.5 2011/04/29 08:26:33 matt Exp $");
 
 #include <sys/param.h>
@@ -78,6 +78,7 @@
 rmixl_ohci_attach(device_t parent, device_t self, void *aux)
 {
-	ohci_softc_t *sc = device_private(self);
-	struct rmixl_usbi_attach_args *usbi = aux;
+	ohci_softc_t * const sc = device_private(self);
+	rmixl_usbi_softc_t * const psc = device_private(parent);
+	struct rmixl_usbi_attach_args * const usbi = aux;
 	void *ih = NULL;
 	uint32_t r;
@@ -127,6 +128,13 @@
 	}
 
+	if (psc->sc_ohci_devs[0] == NULL) {
+		psc->sc_ohci_devs[0] = self;
+	} else if (psc->sc_ohci_devs[1] == NULL) {
+		psc->sc_ohci_devs[1] = self;
+	} else {
+		panic("%s: too many ohci devices", __func__);
+	}
+
 	/* Attach USB device */
 	sc->sc_child = config_found(self, &sc->sc_bus, usbctlprint);
 }
-
Index: /trunk/src/sys/arch/mips/rmi/rmixl_pcie.c
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_pcie.c	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_pcie.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_pcie.c,v 1.1.2.14 2010/05/08 18:08:34 matt Exp $	*/
+/*	$NetBSD: rmixl_pcie.c,v 1.1.2.17 2011/04/29 08:26:33 matt Exp $	*/
 
 /*
@@ -41,5 +41,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: rmixl_pcie.c,v 1.1.2.14 2010/05/08 18:08:34 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: rmixl_pcie.c,v 1.1.2.17 2011/04/29 08:26:33 matt Exp $");
 
 #include "opt_pci.h"
@@ -53,4 +53,6 @@
 #include <sys/extent.h>
 #include <sys/malloc.h>
+#include <sys/kernel.h>		/* for 'hz' */
+#include <sys/cpu.h>
 
 #include <uvm/uvm_extern.h>
@@ -158,4 +160,7 @@
 		((((uint64_t)RMIXL_PCIE_LINK_STATUS1_ERRORS) << 32) |	\
 		   (uint64_t)RMIXL_PCIE_LINK_STATUS0_ERRORS)
+
+#define RMIXL_PCIE_EVCNT(sc, link, bitno, cpu)	\
+		&(sc)->sc_evcnts[link][(bitno) * (ncpu) + (cpu)]
 
 static int	rmixl_pcie_match(device_t, cfdata_t, void *);
@@ -196,4 +201,8 @@
 static void	*rmixl_pcie_intr_establish(void *, pci_intr_handle_t,
 		    int, int (*)(void *), void *);
+static rmixl_pcie_link_intr_t *
+		rmixl_pcie_lip_add_1(rmixl_pcie_softc_t *, u_int, int, int);
+static void	rmixl_pcie_lip_free_callout(rmixl_pcie_link_intr_t *);
+static void	rmixl_pcie_lip_free(void *);
 static int	rmixl_pcie_intr(void *);
 static void	rmixl_pcie_link_error_intr(u_int, uint32_t, uint32_t);
@@ -203,10 +212,4 @@
 static int	_rmixl_pcie_error_check(void *);
 static int	rmixl_pcie_error_intr(void *);
-
-/*
- * XXX use locks
- */
-#define	PCI_CONF_LOCK(s)	(s) = splhigh()
-#define	PCI_CONF_UNLOCK(s)	splx((s))
 
 
@@ -289,4 +292,6 @@
 	aprint_normal(" RMI XLS PCIe Interface\n");
 
+	mutex_init(&sc->sc_mutex, MUTEX_DEFAULT, IPL_HIGH);
+
 	rmixl_pcie_lnkcfg(sc);
 
@@ -547,6 +552,7 @@
 rmixl_pcie_intcfg(struct rmixl_pcie_softc *sc)
 {
-	rmixl_pcie_link_intr_t *lip;
 	int link;
+	size_t size;
+	rmixl_pcie_evcnt_t *ev;
 
 	DPRINTF(("%s: disable all link interrupts\n", __func__));
@@ -557,9 +563,23 @@
 			RMIXL_PCIE_LINK_STATUS1_ERRORS); 
 		RMIXL_IOREG_WRITE(RMIXL_IO_DEV_PCIE_LE + msi_enb_offset[link], 0); 
-		lip = &sc->sc_link_intr[link];
-		LIST_INIT(&lip->dispatch);
-		lip->ih = NULL;
-		lip->link = link;
-		lip->enabled = false;
+		sc->sc_link_intr[link] = NULL;
+
+		/*
+		 * allocate per-cpu, per-pin interrupt event counters
+		 */
+		size = ncpu * PCI_INTERRUPT_PIN_MAX * sizeof(rmixl_pcie_evcnt_t);
+		ev = malloc(size, M_DEVBUF, M_NOWAIT);
+		if (ev == NULL)
+			panic("%s: cannot malloc evcnts\n", __func__);
+		sc->sc_evcnts[link] = ev;
+		for (int pin=PCI_INTERRUPT_PIN_A; pin <= PCI_INTERRUPT_PIN_MAX; pin++) {
+			for (int cpu=0; cpu < ncpu; cpu++) {
+				ev = RMIXL_PCIE_EVCNT(sc, link, pin - 1, cpu);
+				snprintf(ev->name, sizeof(ev->name),
+					"cpu%d, link %d, pin %d", cpu, link, pin);
+				evcnt_attach_dynamic(&ev->evcnt, EVCNT_TYPE_INTR,
+					NULL, "rmixl_pcie", ev->name);
+			}
+		}
 	}
 }
@@ -957,7 +977,6 @@
 	pcireg_t rv;
 	uint64_t cfg0;
-	u_int s;
-
-	PCI_CONF_LOCK(s);
+
+	mutex_enter(&sc->sc_mutex);
 
 	if (rmixl_pcie_conf_setup(sc, tag, &offset, &bst, &bsh) == 0) {
@@ -979,5 +998,6 @@
 	}
 
-	PCI_CONF_UNLOCK(s);
+	mutex_exit(&sc->sc_mutex);
+
 	return rv;
 }
@@ -990,7 +1010,6 @@
 	bus_space_tag_t bst;
 	uint64_t cfg0;
-	u_int s;
-
-	PCI_CONF_LOCK(s);
+
+	mutex_enter(&sc->sc_mutex);
 
 	if (rmixl_pcie_conf_setup(sc, tag, &offset, &bst, &bsh) == 0) {
@@ -1009,5 +1028,5 @@
 	}
 
-	PCI_CONF_UNLOCK(s);
+	mutex_exit(&sc->sc_mutex);
 }
 
@@ -1094,5 +1113,5 @@
 		case 26:
 		case 27:
-			name = rmixl_intr_string(irq);
+			name = rmixl_intr_string(RMIXL_IRT_VECTOR(irq));
 			break;
 		}
@@ -1105,5 +1124,5 @@
 		case 26:
 		case 27:
-			name = rmixl_intr_string(irq);
+			name = rmixl_intr_string(RMIXL_IRT_VECTOR(irq));
 			break;
 		}
@@ -1119,5 +1138,5 @@
 		case 28:
 		case 29:
-			name = rmixl_intr_string(irq);
+			name = rmixl_intr_string(RMIXL_IRT_VECTOR(irq));
 			break;
 		}
@@ -1170,47 +1189,70 @@
 	rmixl_pcie_softc_t *sc = v;
 	rmixl_pcie_link_dispatch_t *dip = ih;
-	rmixl_pcie_link_intr_t *lip = &sc->sc_link_intr[dip->link];;
+	rmixl_pcie_link_intr_t *lip = sc->sc_link_intr[dip->link];
 	uint32_t r;
 	uint32_t bit;
 	u_int offset;
 	u_int other;
+	bool busy;
 
 	DPRINTF(("%s: link=%d pin=%d irq=%d\n",
 		__func__, dip->link, dip->bitno + 1, dip->irq));
-	LIST_REMOVE(dip, next);
-
-	rmixl_intr_disestablish(lip->ih);
-
-	if (dip->bitno < 32) {
-		bit = 1 << dip->bitno;
-		offset = int_enb_offset[dip->link].r0;
-		other  = int_enb_offset[dip->link].r1;
-	} else {
-		bit = 1 << (dip->bitno - 32);
-		offset = int_enb_offset[dip->link].r1;
-		other  = int_enb_offset[dip->link].r0;
-	}
-
-	/* disable this interrupt in the PCIe bridge */
-	r = RMIXL_IOREG_READ(RMIXL_IO_DEV_PCIE_LE + offset);
-	r &= ~bit;
-	RMIXL_IOREG_WRITE(RMIXL_IO_DEV_PCIE_LE + offset, r);
-
-	/*
-	 * if both STATUS0 and STATUS1 are 0
-	 * mark the link interrupt disabled
+
+	mutex_enter(&sc->sc_mutex);
+
+	dip->func = NULL;	/* mark unused, prevent further dispatch */
+
+	/*
+	 * if no other dispatch handle is using this interrupt,
+	 * we can disable it
 	 */
-	if (r == 0) {
-		/* check the other reg */
-		if (RMIXL_IOREG_READ(RMIXL_IO_DEV_PCIE_LE + other) == 0) {
-			lip->enabled = false;
-			DPRINTF(("%s: disabled link %d\n", __func__, lip->link));
-		}
-	}
-
-	evcnt_detach(&dip->count);
-
-	free(dip, M_DEVBUF);
-
+	busy = false;
+	for (int i=0; i < lip->dispatch_count; i++) {
+		rmixl_pcie_link_dispatch_t *d = &lip->dispatch_data[i];
+		if (d == dip)
+			continue;
+		if (d->bitno == dip->bitno) {
+			busy = true;
+			break;
+		}
+	}
+	if (! busy) {
+		if (dip->bitno < 32) {
+			bit = 1 << dip->bitno;
+			offset = int_enb_offset[dip->link].r0;
+			other  = int_enb_offset[dip->link].r1;
+		} else {
+			bit = 1 << (dip->bitno - 32);
+			offset = int_enb_offset[dip->link].r1;
+			other  = int_enb_offset[dip->link].r0;
+		}
+
+		/* disable this interrupt in the PCIe bridge */
+		r = RMIXL_IOREG_READ(RMIXL_IO_DEV_PCIE_LE + offset);
+		r &= ~bit;
+		RMIXL_IOREG_WRITE(RMIXL_IO_DEV_PCIE_LE + offset, r);
+
+		/*
+		 * if both ENABLE0 and ENABLE1 are 0
+		 * disable the link interrupt
+		 */
+		if (r == 0) {
+			/* check the other reg */
+			if (RMIXL_IOREG_READ(RMIXL_IO_DEV_PCIE_LE + other) == 0) {
+				DPRINTF(("%s: disable link %d\n", __func__, lip->link));
+
+				/* tear down interrupt on this link */
+				rmixl_intr_disestablish(lip->ih);
+
+				/* commit NULL interrupt set */
+				sc->sc_link_intr[dip->link] = NULL;
+
+				/* schedule delayed free of the old link interrupt set */
+				rmixl_pcie_lip_free_callout(lip);
+			}
+		}
+	}
+
+	mutex_exit(&sc->sc_mutex);
 }
 
@@ -1223,8 +1265,7 @@
 	uint32_t r;
 	rmixl_pcie_link_intr_t *lip;
-	rmixl_pcie_link_dispatch_t *dip;
+	rmixl_pcie_link_dispatch_t *dip = NULL;
 	uint32_t bit;
 	u_int offset;
-	int s;
 
 	if (pih == ~0) {
@@ -1235,44 +1276,17 @@
 
 	rmixl_pcie_decompose_pih(pih, &link, &bitno, &irq);
-	DPRINTF(("%s: link=%d pin=%d irq=%d\n", __func__, link, bitno + 1, irq));
-
-	lip = &sc->sc_link_intr[link];
-
-	s = splhigh();
-
-#ifdef DEBUG
-	LIST_FOREACH(dip, &lip->dispatch, next) {
-		if (dip->bitno == bitno)
-			panic("%s: pin %d alread on dispatch list",
-				__func__, bitno + 1);
-	}
-#endif
-
-	/*
-	 * all intrs on a link get same ipl and sc
-	 * first intr established sets the standard
+	DPRINTF(("%s: link=%d pin=%d irq=%d\n",
+		__func__, link, bitno + 1, irq));
+
+	mutex_enter(&sc->sc_mutex);
+
+	lip = rmixl_pcie_lip_add_1(sc, link, irq, ipl);
+	if (lip == NULL)
+		return NULL;
+
+	/*
+	 * initializae our new interrupt, the last element in dispatch_data[]
 	 */
-	if (lip->enabled == true) {
-		KASSERT(sc == lip->sc);
-		if (sc != lip->sc) {
-			printf("%s: sc %p mismatch\n", __func__, sc); 
-			goto out;
-		}
-		KASSERT(ipl == lip->ipl);
-		if (ipl != lip->ipl) {
-			printf("%s: ipl %d mismatch\n", __func__, ipl); 
-			goto out;
-		}
-	}
-
-	/*
-	 * allocate and initialize a dispatch handle
-	 */
-	dip = malloc(sizeof(*dip), M_DEVBUF, M_NOWAIT);
-	if (dip == NULL) {
-		printf("%s: cannot malloc dispatch handle\n", __func__);
-		goto out;
-	}
-
+	dip = &lip->dispatch_data[lip->dispatch_count - 1];
 	dip->link = link;
 	dip->bitno = bitno;
@@ -1280,8 +1294,5 @@
 	dip->func = func;
 	dip->arg = arg;
-	snprintf(dip->count_name, sizeof(dip->count_name),
-		"link %d, pin %d", link, bitno + 1);
-	evcnt_attach_dynamic(&dip->count, EVCNT_TYPE_INTR, NULL,
-		"rmixl_pcie", dip->count_name);
+	dip->counts = RMIXL_PCIE_EVCNT(sc, link, bitno, 0);
 
 	if (bitno < 32) {
@@ -1293,4 +1304,7 @@
 	}
 
+	/* commit the new link interrupt set */
+	sc->sc_link_intr[link] = lip;
+
 	/* enable this interrupt in the PCIe bridge */
 	r = RMIXL_IOREG_READ(RMIXL_IO_DEV_PCIE_LE + offset); 
@@ -1298,21 +1312,113 @@
 	RMIXL_IOREG_WRITE(RMIXL_IO_DEV_PCIE_LE + offset, r); 
 
-	if (lip->enabled == false) {
-		lip->ih = rmixl_intr_establish(irq, sc->sc_tmsk,
+	mutex_exit(&sc->sc_mutex);
+	return dip;
+}
+
+rmixl_pcie_link_intr_t *
+rmixl_pcie_lip_add_1(rmixl_pcie_softc_t *sc, u_int link, int irq, int ipl)
+{
+	rmixl_pcie_link_intr_t *lip_old = sc->sc_link_intr[link];
+	rmixl_pcie_link_intr_t *lip_new;
+	u_int dispatch_count;
+	size_t size;
+
+	dispatch_count = 1;
+	size = sizeof(rmixl_pcie_link_intr_t);
+	if (lip_old != NULL) {
+		/*
+		 * count only those dispatch elements still in use
+		 * unused ones will be pruned during copy
+		 * i.e. we are "lazy" there is no rmixl_pcie_lip_sub_1
+                 */     
+		for (int i=0; i < lip_old->dispatch_count; i++) {
+			if (lip_old->dispatch_data[i].func != NULL) {
+				dispatch_count++;
+				size += sizeof(rmixl_pcie_link_intr_t);
+			}
+		}
+	}
+
+	/*
+	 * allocate and initialize link intr struct
+	 * with one or more dispatch handles
+	 */
+	lip_new = malloc(size, M_DEVBUF, M_NOWAIT);
+	if (lip_new == NULL) {
+#ifdef DIAGNOSTIC
+		printf("%s: cannot malloc\n", __func__);
+#endif
+		return NULL;
+	}
+
+	if (lip_old == NULL) {
+		/* initialize the link interrupt struct */
+		lip_new->sc = sc;
+		lip_new->link = link;
+		lip_new->ipl = ipl;
+		lip_new->ih = rmixl_intr_establish(irq, sc->sc_tmsk,
 			ipl, RMIXL_TRIG_LEVEL, RMIXL_POLR_HIGH,
-			rmixl_pcie_intr, lip, false);
-		if (lip->ih == NULL)
+			rmixl_pcie_intr, lip_new, false);
+		if (lip_new->ih == NULL)
 			panic("%s: cannot establish irq %d", __func__, irq);
-
-		lip->sc = sc;
-		lip->ipl = ipl;
-		lip->enabled = true;
-		DPRINTF(("%s: enabled link %d\n", __func__, link));
-	}
-	LIST_INSERT_HEAD(&lip->dispatch, dip, next);
-
- out:
-	splx(s);
-	return dip;
+	} else {
+		/*
+		 * all intrs on a link get same ipl and sc
+		 * first intr established sets the standard
+		 */
+		KASSERT(sc == lip_old->sc);
+		if (sc != lip_old->sc) {
+			printf("%s: sc %p mismatch\n", __func__, sc); 
+			free(lip_new, M_DEVBUF);
+			return NULL;
+		}
+		KASSERT (ipl == lip_old->ipl);
+		if (ipl != lip_old->ipl) {
+			printf("%s: ipl %d mismatch\n", __func__, ipl); 
+			free(lip_new, M_DEVBUF);
+			return NULL;
+		}
+		/*
+		 * copy lip_old to lip_new, skipping unused dispatch elemets
+		 */
+		memcpy(lip_new, lip_old, sizeof(rmixl_pcie_link_intr_t));
+		for (int j=0, i=0; i < lip_old->dispatch_count; i++) {
+			if (lip_old->dispatch_data[i].func != NULL) {
+				memcpy(&lip_new->dispatch_data[j],
+					&lip_old->dispatch_data[i],
+					sizeof(rmixl_pcie_link_dispatch_t));
+				j++;
+			}
+		}
+
+		/*
+		 * schedule delayed free of old link interrupt set
+		 */
+		rmixl_pcie_lip_free_callout(lip_old);
+	}
+	lip_new->dispatch_count = dispatch_count;
+
+	return lip_new;
+}
+
+/*
+ * delay free of the old link interrupt set
+ * to allow anyone still using it to do so safely
+ * XXX 2 seconds should be plenty?
+ */
+static void
+rmixl_pcie_lip_free_callout(rmixl_pcie_link_intr_t *lip)
+{
+	callout_init(&lip->callout, 0);
+	callout_reset(&lip->callout, 2 * hz, rmixl_pcie_lip_free, lip);
+}
+
+static void
+rmixl_pcie_lip_free(void *arg)
+{
+	rmixl_pcie_link_intr_t *lip = arg;
+	
+	callout_destroy(&lip->callout);
+	free(lip, M_DEVBUF);
 }
 
@@ -1335,10 +1441,14 @@
 			rmixl_pcie_link_error_intr(link, status0, status1);
 
-		LIST_FOREACH(dip, &lip->dispatch, next) {
-			uint64_t bit = 1 << dip->bitno;
-			if ((status & bit) != 0) {
-				(void)(*dip->func)(dip->arg);
-				dip->count.ev_count++;
-				rv = 1;
+		for (u_int i=0; i < lip->dispatch_count; i++) {
+			dip = &lip->dispatch_data[i];
+			int (*func)(void *) = dip->func;
+			if (func != NULL) {
+				uint64_t bit = 1 << dip->bitno;
+				if ((status & bit) != 0) {
+					(void)(*func)(dip->arg);
+					dip->counts[cpu_index(curcpu())].evcnt.ev_count++;
+					rv = 1;
+				}
 			}
 		}
Index: /trunk/src/sys/arch/mips/rmi/rmixl_pcievar.h
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_pcievar.h	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_pcievar.h	(revision 152)
@@ -1,3 +1,3 @@
-/*      $NetBSD: rmixl_pcievar.h,v 1.1.2.7 2010/04/13 18:15:16 cliff Exp $	*/
+/*      $NetBSD: rmixl_pcievar.h,v 1.1.2.8 2010/09/20 19:42:31 cliff Exp $	*/
 /*-
  * Copyright (c) 2010 The NetBSD Foundation, Inc.
@@ -51,6 +51,10 @@
 } rmixl_pcie_lnktab_t;
 
+typedef struct rmixl_pcie_evcnt {
+	struct evcnt evcnt;
+	char name[32];
+} rmixl_pcie_evcnt_t;
+
 typedef struct rmixl_pcie_link_dispatch {
-	LIST_ENTRY(rmixl_pcie_link_dispatch) next;
 	int (*func)(void *);
 	void *arg;
@@ -58,6 +62,5 @@
 	u_int bitno;
 	u_int irq;
-	struct evcnt count;
-	char count_name[32];
+	rmixl_pcie_evcnt_t *counts;	/* index by cpu */
 } rmixl_pcie_link_dispatch_t;
 
@@ -66,9 +69,11 @@
 typedef struct rmixl_pcie_link_intr {
 	struct rmixl_pcie_softc *sc;
-	LIST_HEAD(, rmixl_pcie_link_dispatch) dispatch;
 	u_int link;
 	u_int ipl;
-	bool enabled;
 	void *ih;			/* mips interrupt handle */
+	callout_t callout;		/* for delayed free of this struct */
+	u_int dispatch_count;
+	rmixl_pcie_link_dispatch_t  dispatch_data[1];
+					/* variable length */
 } rmixl_pcie_link_intr_t;
 
@@ -84,7 +89,9 @@
 	bus_dma_tag_t			sc_64bit_dmat;
 	rmixl_pcie_lnktab_t		sc_pcie_lnktab;
+	kmutex_t			sc_mutex;
 	int				sc_tmsk;
 	void 			       *sc_fatal_ih;
-	rmixl_pcie_link_intr_t		sc_link_intr[RMIXL_PCIE_NLINKS_MAX];
+	rmixl_pcie_evcnt_t	       *sc_evcnts[RMIXL_PCIE_NLINKS_MAX];
+	rmixl_pcie_link_intr_t	       *sc_link_intr[RMIXL_PCIE_NLINKS_MAX];
 } rmixl_pcie_softc_t;
 
Index: /trunk/src/sys/arch/mips/rmi/rmixl_pcix.c
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_pcix.c	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_pcix.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rmixl_pcix.c,v 1.1.2.5 2010/04/17 07:34:08 cliff Exp $	*/
+/*	$NetBSD: rmixl_pcix.c,v 1.1.2.9 2011/04/29 08:26:33 matt Exp $	*/
 
 /*
@@ -41,5 +41,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: rmixl_pcix.c,v 1.1.2.5 2010/04/17 07:34:08 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: rmixl_pcix.c,v 1.1.2.9 2011/04/29 08:26:33 matt Exp $");
 
 #include "opt_pci.h"
@@ -53,4 +53,6 @@
 #include <sys/extent.h>
 #include <sys/malloc.h>
+#include <sys/kernel.h>		/* for 'hz' */
+#include <sys/cpu.h>
 
 #include <uvm/uvm_extern.h>
@@ -190,10 +192,4 @@
 #define RMIXL_PCIXREG_WRITE(o,v)  *RMIXL_PCIXREG_VADDR(o) = (v)
 
-/*
- * XXX use locks
- */
-#define	PCI_CONF_LOCK(s)	(s) = splhigh()
-#define	PCI_CONF_UNLOCK(s)	splx((s))
-
 
 #define RMIXL_PCIX_CONCAT3(a,b,c) a ## b ## c
@@ -223,4 +219,9 @@
 }
 
+
+#define RMIXL_PCIX_EVCNT(sc, intrpin, cpu)	\
+	&(sc)->sc_evcnts[(intrpin) * (ncpu) + (cpu)]
+
+
 static int	rmixl_pcix_match(device_t, cfdata_t, void *);
 static void	rmixl_pcix_attach(device_t, device_t, void *);
@@ -254,4 +255,8 @@
 static void	*rmixl_pcix_intr_establish(void *, pci_intr_handle_t,
 		    int, int (*)(void *), void *);
+static rmixl_pcix_intr_t *
+                rmixl_pcix_pip_add_1(rmixl_pcix_softc_t *, int, int);
+static void     rmixl_pcix_pip_free_callout(rmixl_pcix_intr_t *);
+static void     rmixl_pcix_pip_free(void *);
 static int	rmixl_pcix_intr(void *);
 static int	rmixl_pcix_error_intr(void *);
@@ -263,8 +268,4 @@
 
 static int rmixl_pcix_found;
-
-#if defined(DIAGNOSTIC) || defined(DEBUG) || defined(DDB)
-static rmixl_pcix_softc_t *rmixl_pcix_sc;
-#endif
 
 
@@ -308,7 +309,4 @@
 
 	rmixl_pcix_found = 1;
-#ifdef DIAGNOSTIC
-	rmixl_pcix_sc = sc;
-#endif
 	sc->sc_dev = self;
 	sc->sc_29bit_dmat = obio->obio_29bit_dmat;
@@ -318,4 +316,6 @@
 
 	aprint_normal(": RMI XLR PCI-X Interface\n");
+
+	mutex_init(&sc->sc_mutex, MUTEX_DEFAULT, IPL_HIGH);
 
 	rmixl_pcix_intcfg(sc);
@@ -483,4 +483,7 @@
 rmixl_pcix_intcfg(rmixl_pcix_softc_t *sc)
 {
+	size_t size;
+	rmixl_pcix_evcnt_t *ev;
+
 	DPRINTF(("%s\n", __func__));
 
@@ -496,19 +499,28 @@
 	(void)RMIXL_PCIXREG_READ(RMIXL_PCIX_ECFG_INTR_ERR_STATUS); 
 
-	/* initialize the dispatch handles */
-	for (int i=0; i < RMIXL_PCIX_NINTR; i++) {
-		rmixl_pcix_intr_t *ih = &sc->sc_intr[i];
-		LIST_INIT(&ih->dispatch);
-		ih->ih = NULL;
-		ih->intrpin = i;
-		ih->enabled = false;
-	}
-
-	sc->sc_ih = rmixl_intr_establish(16, sc->sc_tmsk,
-		IPL_VM, RMIXL_TRIG_LEVEL, RMIXL_POLR_HIGH,
-		rmixl_pcix_intr, sc, false);
-	if (sc->sc_ih == NULL)
-		panic("%s: cannot establish irq %d", __func__, 16);
-
+	/* initialize the (non-error interrupt) dispatch handles */
+	sc->sc_intr = NULL;
+
+	/*
+	 * allocate per-cpu, per-pin interrupt event counters
+	 */
+	size = ncpu * PCI_INTERRUPT_PIN_MAX * sizeof(rmixl_pcix_evcnt_t);
+	ev = malloc(size, M_DEVBUF, M_NOWAIT);
+	if (ev == NULL)
+		panic("%s: cannot malloc evcnts\n", __func__);
+	sc->sc_evcnts = ev;
+	for (int pin=PCI_INTERRUPT_PIN_A; pin <= PCI_INTERRUPT_PIN_MAX; pin++) {
+		for (int cpu=0; cpu < ncpu; cpu++) {
+			ev = RMIXL_PCIX_EVCNT(sc, pin - 1, cpu);
+			snprintf(ev->name, sizeof(ev->name),
+				"cpu%d, pin %d", cpu, pin);
+			evcnt_attach_dynamic(&ev->evcnt, EVCNT_TYPE_INTR,
+				NULL, "rmixl_pcix", ev->name);
+		}
+	}
+
+	/*
+	 * establish PCIX error interrupt handler
+	 */
 	sc->sc_fatal_ih = rmixl_intr_establish(24, sc->sc_tmsk,
 		IPL_VM, RMIXL_TRIG_LEVEL, RMIXL_POLR_HIGH,
@@ -516,6 +528,4 @@
 	if (sc->sc_fatal_ih == NULL)
 		panic("%s: cannot establish irq %d", __func__, 24);
-
-	sc->sc_intr_init_done = true;
 }
 
@@ -703,7 +713,6 @@
 	pcireg_t rv;
 	uint64_t cfg0;
-	u_int s;
-
-	PCI_CONF_LOCK(s);
+
+	mutex_enter(&sc->sc_mutex);
 
 	if (rmixl_pcix_conf_setup(sc, tag, &offset, &bst, &bsh) == 0) {
@@ -725,5 +734,6 @@
 	}
 
-	PCI_CONF_UNLOCK(s);
+	mutex_exit(&sc->sc_mutex);
+
 	return rv;
 }
@@ -736,7 +746,6 @@
 	bus_space_tag_t bst;
 	uint64_t cfg0;
-	u_int s;
-
-	PCI_CONF_LOCK(s);
+
+	mutex_enter(&sc->sc_mutex);
 
 	if (rmixl_pcix_conf_setup(sc, tag, &offset, &bst, &bsh) == 0) {
@@ -755,5 +764,5 @@
 	}
 
-	PCI_CONF_UNLOCK(s);
+	mutex_exit(&sc->sc_mutex);
 }
 
@@ -789,5 +798,5 @@
 			__func__, mips_options.mips_cpu_id);
 
-	return rmixl_intr_string(irq);
+	return rmixl_intr_string(RMIXL_IRT_VECTOR(irq));
 }
 
@@ -827,5 +836,6 @@
 	rmixl_pcix_softc_t *sc = v;
 	rmixl_pcix_dispatch_t *dip = ih;
-	rmixl_pcix_intr_t *pip = &sc->sc_intr[dip->bitno];;
+	rmixl_pcix_intr_t *pip = sc->sc_intr;
+	bool busy;
 
 	DPRINTF(("%s: pin=%d irq=%d\n",
@@ -833,9 +843,23 @@
 	KASSERT(dip->bitno < RMIXL_PCIX_NINTR);
 
-	LIST_REMOVE(dip, next);
-	evcnt_detach(&dip->count);
-	free(dip, M_DEVBUF);
-
-	if (LIST_EMPTY(&pip->dispatch)) {
+	mutex_enter(&sc->sc_mutex);
+
+	dip->func = NULL;	/* prevent further dispatch */
+
+	/*
+	 * if no other dispatch handle is using this interrupt,
+	 * we can disable it
+	 */
+	busy = false;
+	for (int i=0; i < pip->dispatch_count; i++) {
+		rmixl_pcix_dispatch_t *d = &pip->dispatch_data[i];
+		if (d == dip)
+			continue;
+		if (d->bitno == dip->bitno) {
+			busy = true;
+			break;
+		}
+	}
+	if (! busy) {
 		uint32_t bit = 1 << (dip->bitno + 2);
 		uint32_t r;
@@ -846,6 +870,19 @@
 		DPRINTF(("%s: disabled pin %d\n", __func__, dip->bitno + 1));
 
-		pip->enabled = false;
-	}
+		pip->intenb &= ~(1 << dip->bitno);
+
+		if ((r & PCIX_INTR_CONTROL_MASK_ALL) == 0) {
+			/* tear down interrupt for this pcix */
+			rmixl_intr_disestablish(pip->ih);
+
+			/* commit NULL interrupt set */
+			sc->sc_intr = NULL;
+
+			/* schedule delayed free of the old interrupt set */
+			rmixl_pcix_pip_free_callout(pip);
+		}
+	}
+
+	mutex_exit(&sc->sc_mutex);
 }
 
@@ -857,6 +894,5 @@
 	u_int bitno, irq;
 	rmixl_pcix_intr_t *pip;
-	rmixl_pcix_dispatch_t *dip;
-	int s;
+	rmixl_pcix_dispatch_t *dip = NULL;
 
 	if (pih == ~0) {
@@ -870,33 +906,37 @@
 
 	KASSERT(bitno < RMIXL_PCIX_NINTR);
-	pip = &sc->sc_intr[bitno];
-
-	s = splhigh();
-
-	/*
-	 * all PCI-X device intrs get same ipl and sc
-	 */
-	KASSERT(sc == rmixl_pcix_sc);
+
+	/*
+	 * all PCI-X device intrs get same ipl
+	 */
 	KASSERT(ipl == IPL_VM);
 
-	/*
-	 * allocate and initialize a dispatch handle
-	 */
-	dip = malloc(sizeof(*dip), M_DEVBUF, M_NOWAIT);
-	if (dip == NULL) {
-		printf("%s: cannot malloc dispatch handle\n", __func__);
-		goto out;
-	}
-
+	mutex_enter(&sc->sc_mutex);
+
+	pip = rmixl_pcix_pip_add_1(sc, irq, ipl); 
+	if (pip == NULL)
+		return NULL;
+
+	/*
+	 * initializae our new interrupt, the last element in dispatch_data[] 
+	 */
+	dip = &pip->dispatch_data[pip->dispatch_count - 1];
 	dip->bitno = bitno;
 	dip->irq = irq;
 	dip->func = func;
 	dip->arg = arg;
+	dip->counts = RMIXL_PCIX_EVCNT(sc, bitno, 0);
+#if NEVER
 	snprintf(dip->count_name, sizeof(dip->count_name),
 		"pin %d", bitno + 1);
 	evcnt_attach_dynamic(&dip->count, EVCNT_TYPE_INTR, NULL,
 		"rmixl_pcix", dip->count_name);
-
-	if (pip->enabled == false) {
+#endif
+
+	/* commit the new interrupt set */
+	sc->sc_intr = pip;
+
+	/* enable this interrupt in the PCIX controller, if necessary */
+	if ((pip->intenb & (1 << bitno)) == 0) {
 		uint32_t bit = 1 << (bitno + 2);
 		uint32_t r;
@@ -908,13 +948,116 @@
 		pip->sc = sc;
 		pip->ipl = ipl;
-		pip->enabled = true;
+		pip->intenb |= 1 << bitno;
 		DPRINTF(("%s: enabled pin %d\n", __func__, bitno + 1));
 	}
 
-	LIST_INSERT_HEAD(&pip->dispatch, dip, next);
-
- out:
-	splx(s);
+	mutex_exit(&sc->sc_mutex);
 	return dip;
+}
+
+rmixl_pcix_intr_t *
+rmixl_pcix_pip_add_1(rmixl_pcix_softc_t *sc, int irq, int ipl)
+{
+	rmixl_pcix_intr_t *pip_old = sc->sc_intr;
+	rmixl_pcix_intr_t *pip_new;
+	u_int dispatch_count;
+	size_t size;
+
+	dispatch_count = 1;
+	size = sizeof(rmixl_pcix_intr_t);
+	if (pip_old != NULL) {
+		/*
+		 * count only those dispatch elements still in use
+		 * unused ones will be pruned during copy
+		 * i.e. we are "lazy" there is no rmixl_pcix_pip_sub_1
+		 */
+		for (int i=0; i < pip_old->dispatch_count; i++) {
+			if (pip_old->dispatch_data[i].func != NULL) {
+				dispatch_count++;
+				size += sizeof(rmixl_pcix_intr_t);
+			}
+		}
+	}
+
+	/*
+	 * allocate and initialize softc intr struct
+	 * with one or more dispatch handles
+	 */
+	pip_new = malloc(size, M_DEVBUF, M_NOWAIT|M_ZERO);
+	if (pip_new == NULL) {
+#ifdef DIAGNOSTIC
+		printf("%s: cannot malloc\n", __func__);
+#endif
+		return NULL;
+	}
+
+	if (pip_old == NULL) {
+		/* initialize the interrupt struct */
+		pip_new->sc = sc;
+		pip_new->ipl = ipl;
+		pip_new->ih = rmixl_intr_establish(irq, sc->sc_tmsk,
+			ipl, RMIXL_TRIG_LEVEL, RMIXL_POLR_HIGH,
+			rmixl_pcix_intr, pip_new, false);
+		if (pip_new->ih == NULL)
+			panic("%s: cannot establish irq %d", __func__, irq);
+	} else {
+		/*
+		 * all intrs on a softc get same ipl and sc
+		 * first intr established sets the standard
+		 */
+		KASSERT(sc == pip_old->sc);
+		if (sc != pip_old->sc) {
+			printf("%s: sc %p mismatch\n", __func__, sc); 
+			free(pip_new, M_DEVBUF);
+			return NULL;
+		}
+		KASSERT (ipl == pip_old->ipl);
+		if (ipl != pip_old->ipl) {
+			printf("%s: ipl %d mismatch\n", __func__, ipl); 
+			free(pip_new, M_DEVBUF);
+			return NULL;
+		}
+		/*
+		 * copy pip_old to pip_new, skipping unused dispatch elemets
+		 */
+		memcpy(pip_new, pip_old, sizeof(rmixl_pcix_intr_t));
+		for (int j=0, i=0; i < pip_old->dispatch_count; i++) {
+			if (pip_old->dispatch_data[i].func != NULL) {
+				memcpy(&pip_new->dispatch_data[j],
+					&pip_old->dispatch_data[i],
+					sizeof(rmixl_pcix_dispatch_t));
+				j++;
+			}
+		}
+
+		/*
+		 * schedule delayed free of old interrupt set
+		 */
+		rmixl_pcix_pip_free_callout(pip_old);
+	}
+	pip_new->dispatch_count = dispatch_count;
+
+	return pip_new;
+}
+
+/*
+ * delay free of the old interrupt set
+ * to allow anyone still using it to do so safely
+ * XXX 2 seconds should be plenty?
+ */
+static void
+rmixl_pcix_pip_free_callout(rmixl_pcix_intr_t *pip)
+{
+	callout_init(&pip->callout, 0);
+	callout_reset(&pip->callout, 2 * hz, rmixl_pcix_pip_free, pip);
+}       
+        
+static void
+rmixl_pcix_pip_free(void *arg)
+{       
+	rmixl_pcix_intr_t *pip = arg;
+
+	callout_destroy(&pip->callout);
+	free(pip, M_DEVBUF);
 }
 
@@ -922,5 +1065,5 @@
 rmixl_pcix_intr(void *arg)
 {
-	rmixl_pcix_softc_t *sc = arg;
+	rmixl_pcix_intr_t *pip = arg;
 	int rv = 0;
 
@@ -929,14 +1072,12 @@
 
 	if (status != 0) {
-		for (int i=0; i < RMIXL_PCIX_NINTR; i++) {
-			uint32_t bit = 1 << i;
-			if ((status & bit) != 0) {
-				rmixl_pcix_intr_t *pip = &sc->sc_intr[i];
-				rmixl_pcix_dispatch_t *dip;
-				LIST_FOREACH(dip, &pip->dispatch, next) {
-					(void)(*dip->func)(dip->arg);
-					dip->count.ev_count++;
-					rv = 1;
-				}
+		for (int i=0; i < pip->dispatch_count; i++) {
+			rmixl_pcix_dispatch_t *dip = &pip->dispatch_data[i];
+			uint32_t bit = 1 << dip->bitno;
+			int (*func)(void *) = dip->func;
+			if ((func != NULL) && (status & bit) != 0) {
+				(void)(*func)(dip->arg);
+				dip->counts[cpu_index(curcpu())].evcnt.ev_count++;
+				rv = 1;
 			}
 		}
Index: /trunk/src/sys/arch/mips/rmi/rmixl_pcixvar.h
===================================================================
--- /trunk/src/sys/arch/mips/rmi/rmixl_pcixvar.h	(revision 151)
+++ /trunk/src/sys/arch/mips/rmi/rmixl_pcixvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/*      $NetBSD: rmixl_pcixvar.h,v 1.1.2.2 2010/04/13 18:15:16 cliff Exp $	*/
+/*      $NetBSD: rmixl_pcixvar.h,v 1.1.2.3 2010/09/20 19:42:31 cliff Exp $	*/
 /*-
  * Copyright (c) 2010 The NetBSD Foundation, Inc.
@@ -34,12 +34,15 @@
 #include <dev/pci/pcivar.h>
 
+typedef struct rmixl_pcix_evcnt {
+	struct evcnt evcnt;
+	char name[32];
+} rmixl_pcix_evcnt_t;
+
 typedef struct rmixl_pcix_dispatch {
-	LIST_ENTRY(rmixl_pcix_dispatch) next;
 	int (*func)(void *);
 	void *arg;
 	u_int bitno;
 	u_int irq;
-	struct evcnt count;
-	char count_name[32];
+	rmixl_pcix_evcnt_t *counts;	/* index by cpu */
 } rmixl_pcix_dispatch_t;
 
@@ -48,9 +51,12 @@
 typedef struct rmixl_pcix_intr {
 	struct rmixl_pcix_softc *sc;
-	LIST_HEAD(, rmixl_pcix_dispatch) dispatch;
 	u_int intrpin;
 	u_int ipl;
-	bool enabled;
 	void *ih;			/* mips interrupt handle */
+	callout_t callout;		/* for delayed free of this struct */
+	u_int intenb;			/* enabled flags for INT[ABCD] */
+	u_int dispatch_count;
+	rmixl_pcix_dispatch_t dispatch_data[1];
+					/* variable length */
 } rmixl_pcix_intr_t;
 
@@ -65,9 +71,9 @@
 	bus_dma_tag_t			sc_32bit_dmat;
 	bus_dma_tag_t			sc_64bit_dmat;
+	kmutex_t			sc_mutex;
 	int				sc_tmsk;
 	void 			       *sc_fatal_ih;
-	void 			       *sc_ih;
-	rmixl_pcix_intr_t		sc_intr[RMIXL_PCIX_NINTR];
-	bool				sc_intr_init_done;	
+        rmixl_pcix_evcnt_t             *sc_evcnts;
+	rmixl_pcix_intr_t	       *sc_intr;
 } rmixl_pcix_softc_t;
 
